{********************************************************************}
{*                          PARSERS.PAS                             *}
{*                                                                  *}
{*           ꥪ⭮-ਥ஢ 䥩  ப    *}
{*                    䨣樮 䠩                      *}
{*             ॡ  TurboProfessional                 *}
{*                      Object Professional                         *}
{*                                                                  *}
{*              Copyright (c) by SoftWeyr 1992,1993                 *}
{********************************************************************}
unit parsers;
interface
uses TPString;
{᫨    TPString.TPU,  砩.   TPString 
   OPString,  , ᫨  ⮣ ,  ਢ ᠭ
  㭪権  ⨯  TPString, ᯮ㥬   㫥. 
   ᠬ    殬}
Type PByte = ^Byte;
     PLongInt = ^LongInt;
     PBoolean = ^Boolean;
     PString = ^String;
     PFloat = ^Float;
     PObject = ^TObject;
{ᯮ㥬 ⨯  TPString}
{     CharSet = set of char;}
{     Float=Real,᫨ N-  Extended}
     TObject = object
                constructor Init;
                Procedure Free;
                Destructor Done;virtual;
               end;
     PParser = ^TParser;
     POption = ^TOption;
     TParser = Object (TObject)
                ParseStr:String;
                CurPos:Byte;
                NoParams:Boolean;
                SkipUnknown:boolean;
                KeyList:POption;
                Procedure Insert(Key:POption);
                Procedure ParseLine(S:String);
                Procedure SkipWord;
                Procedure SkipSpaces;
                Procedure Error(ErrNum:Integer);Virtual;
                Procedure CheckRequired;
                Destructor Done;virtual;
               end;
     TOption = Object (TObject)
               Owner:PParser;
               Next:POption;
               Procedure Clear;virtual;
               Function IsOption:Boolean;
               Function Processed:boolean;virtual;
               Function Valid:Boolean;virtual;
               end;
     PParameter = ^TParameter;
     TParameter = object (TOption)

                   StringVar:PString;
                   Required:Boolean;
                   Found:Boolean;
                   Constructor Init(var AStringVar;ARequired:Boolean);
                   Procedure Clear;virtual;
                   Function Processed:boolean;virtual;
                   Function Valid:Boolean;virtual;
                  end;
    PKey = ^TKey;
    TKey = Object( TOption )
             Name:PString;
             RelatedVar:Pointer;
             Constructor Init(AName:String;AVar:Pointer);
             Function Prefix(AddDelims:CharSet):Boolean;
             Destructor Done;Virtual;
           end;
    PRealKey = ^TRealKey;
    TRealKey = Object (TKey)
                   Function Processed:boolean;virtual;
               end;
    PIntegerKey = ^TIntegerKey;
    TIntegerKey = Object (TKey)
                   Function Processed:boolean;virtual;
               end;
    PStringKey = ^TStringKey;
    TStringKey = Object (TKey)
                   Function Processed:boolean;virtual;
               end;
    PFileNameKey = ^TFileNameKey;
    TFileNameKey = Object (TKey)
                   Function Processed:boolean;virtual;
               end;
    POnOffKey = ^TOnOffKey;
    TOnOffKey = Object (TKey)
                   Function Processed:boolean;virtual;
               end;
    POffKey = ^TOffKey;
    TOffKey = Object (TKey)
                   Function Processed:boolean;virtual;
               end;
    POnKey = ^TOnKey;
    TOnKey = Object (TKey)
                   Function Processed:boolean;virtual;
               end;
    PImmediateKey = ^TImmediateKey;
    TImmediateKey= Object(TKey)
                    Function Processed:Boolean;virtual;
                   end;
Procedure ParseConfigFile (Parser:PParser;FileName:String);
Procedure ParseCommandLine(Parser:PParser);
Function NewStr(S:String):PString;
Procedure DisposeStr(P:PString);
{----------ᯮ㥬 㭪樨  TPString/OPString---------------------}
{Function Stupcase(S:String):String; - ॢ ப   㪢}
{ Function Str2Real(S:String;var R:Float):Boolean; ॢ ப S }
{ ⢥ ᫮ R,  True, ᫨ 稫}
{Function Str2Long(S:String;var R:LongInt):Boolean;ॢ ப S }
{ 楫 ᫮ R,  True, ᫨ 稫
{Function JustPathName(S:String):String; 뤥    䠩.
 ᫨  ७,   "\" }
{----------------------------------------------------------------------}
Const
 {ࠢ騥 ᨬ}
  {䨪 権}
 OptionPrefix:CharSet=['-','/'];
  {⥫ ᫮}
 WordDelimiters:CharSet=[' ',',',#255,'-','/',';','"'];
  {窨, ࠭稢騥 ப  TStringKey}
 StringTerminator:Char='"';
  {,  ᫥ ⮣ ᨬ, ࠧ  ࣠}
 LineTerminator:Char=';';
 { 訡, ।  TParser.Error}
 peInvalidOption = 1;
 peInvalidNumber = 2;
 peNoClosingQuote = 3;
 peNoRequiredParameter = 4;
Implementation
uses Dos;
Function NewStr(S:String):PString;
var P:PString;
begin
 Getmem(P,Length(S)+1);
 P^:=S;
 NewStr:=P;
end;
Procedure DisposeStr(P:PString);
begin
 FreeMem(P,Length(P^)+1);
end;
Constructor TObject.Init;
begin
 FillChar(Pointer(LongInt(@Self)+2)^,SizeOf(Self),#0);
end;
Procedure TObject.Free;
var P:Pobject;
begin
 P:=@Self;
 Dispose(P,Done);
end;
Destructor TObject.Done;
Begin
end;
Procedure TParser.Insert(Key:POption);
 var P:POption;
 begin
   If Key=nil then exit;
  Key^.Next:=nil;
  Key^.Owner:=@Self;
  if KeyList=nil then KeyList:=Key
   else
   begin
    P:=KeyList;
    While P^.Next<>nil do
     P:=P^.Next;
    P^.Next:=Key;
   end;
  end;
Procedure TParser.ParseLine(S:String);
var P:POption;
begin
 ParseStr:=S;
 ParseStr[Succ(Length(ParseStr))]:=' ';
 CurPos:=1;
 While (CurPos<=Length(ParseStr)) and (ParseStr[CurPos]<>LineTerMinator)do
  begin
   SkipSpaces;
   P:=KeyList;
   While (P<>nil)and not (P^.Processed) do P:=P^.Next;
   if P=nil then
    begin
     if not SkipUnknown then
      Error(peInvalidOption);
     SkipWord
    end;
  end;
end;
Procedure TParser.CheckRequired;
var P:POption;
begin
 P:=KeyList;
 While (P<>nil) and P^.Valid do P:=P^.Next;
 if P<>nil then Error(peNoRequiredParameter);
end;
Procedure TParser.SkipSpaces;
begin
 While (CurPos<=Length(ParseStr))and(ParseStr[CurPos] in WordDelimiters) do
  inc(CurPos);
end;
Procedure TParser.SkipWord;
begin
 While (CurPos<=Length(ParseStr))and not (ParseStr[CurPos] in WordDelimiters) do
 if ParseStr[CurPos]=StringTerminator then
  begin
   inc(Curpos);
   While (CurPos<=Length(ParseStr))and(ParseStr[Curpos]<>StringTerminator)do
    inc(Curpos);
   if Curpos >Length(ParseStr) then Error (peNoClosingQuote)
    else inc(Curpos);
  end
 else Inc(CurPos);
end;
Procedure TParser.Error(ErrNum:Integer);
begin
 Writeln('Error in parameters:');
 Writeln(ParseStr);
 Writeln('^':CurPos);
 Case ErrNum of
  peInvalidOption      :Writeln('Invalid Option');
  peInvalidNumber      :Writeln('Invalid Number');
  peNoClosingQuote     :Writeln('No closing quote');
  peNoRequiredParameter:Writeln('Required parameter missing');
  end;
  Halt;
end;
Destructor TParser.Done;
var P:POption;
begin
 While KeyList<>nil do
 begin;
  P:=KeyList;
  KeyList:=KEyList^.Next;
  Dispose(P,Done);
 end;
end;
Function TOption.IsOption;
begin
  With Owner^ do
 if CurPos=1 then IsOption:=False else
 IsOption:=ParseStr[pred(CurPos)]in OptionPrefix;
end;
Procedure TOption.Clear;
begin
end;
Function TOption.Processed:Boolean;
begin
 Processed:=False;
end;
Function TOption.Valid:Boolean;
begin
 Valid:=True;
end;
Constructor TParameter.Init(var AStringVar;ARequired:Boolean);
begin
 StringVar:=@AStringVar;
 Required:=ARequired;
 Found:=False;
end;
Function TParameter.Processed:Boolean;
var i:Byte;
begin
 if IsOption or Found or Owner^.NoParams then Processed :=False
  else
   begin
    Processed:=True;
    Found:=True;
    With Owner^ do
     begin
      I:=CurPos;
      While (CurPos<=Length(ParseStr))and
      not (ParseStr[CurPos] in WordDelimiters+[StringTerminator,LineTerminator]) do
      inc(CurPos);
      StringVar^:=Copy(ParseStr,i,CurPos-I);
     end;
   end;
end;
Procedure TParameter.Clear;
begin
 Found:=False;
end;
Function TParameter.Valid:Boolean;
begin
 Valid:=Not Required or Found;
end;
Constructor TKey.Init(AName:String;AVar:Pointer);
begin
 Name:=NewStr(StUpCase(Aname));
 RelatedVar:=AVar;
end;
Function TKey.Prefix(AddDelims:CharSet):Boolean;
begin
 {$B-}
 With Owner^ do
 Prefix:=IsOption and (StUpCase(Copy(ParseStr,CurPos,PByte(Name)^))=Name^)
 and(ParseStr[CurPos+PByte(Name)^] in AddDelims)
end;
Destructor TKey.Done;
Begin
 DisposeStr(Name);
end;
Function TRealKey.Processed:Boolean;
const LegalChars:CharSet=['.','-','+','0'..'9','E','e'];
var A:Float;
    i:Byte;
begin
 if Prefix(LegalChars) then
  With Owner^ do
   begin
    i:=Curpos+PByte(Name)^;
    CurPos:=i;
    While (CurPos<=Length(ParseStr))and (ParseStr[CurPos] in LegalChars) do
     inc(CurPos);
    if Not Str2Real(Copy(ParseStr,i,CurPos-i),A) then
     Owner^.Error(peInvalidNumber)
    else
     PFloat(RelatedVar)^:=A;
   Processed:=True;
 end
 else
  Processed:=False;
end;
Function TIntegerKey.Processed:Boolean;
const LegalChars:CharSet=['$','-','+','0'..'9'];
var A:LongInt;
    i:Byte;
begin
 if Prefix(LegalChars) then
  With Owner^ do
   begin
    i:=Curpos+PByte(Name)^;
    CurPos:=i;
    While (CurPos<=Length(ParseStr))and (ParseStr[CurPos] in LegalChars) do
     inc(CurPos);
    if Not Str2Long(Copy(ParseStr,i,CurPos-i),A) then
     Owner^.Error(peInvalidNumber)
    else
     PLongInt(RelatedVar)^:=A;
   Processed:=True;
 end
 else
  Processed:=False;
end;
Function TStringKey.Processed:Boolean;
var i:Byte;
begin
 if Prefix([StringTerminator]) then
  With Owner^ do
  Begin
   I:=CurPos+PByte(Name)^+1;
   SkipWord;
   PString(RelatedVar)^:=Copy(ParseStr,i,CurPos-i-1);
   Processed:=True;
  end
 else
  Processed:=False;
end;
Function TFileNameKey.Processed:Boolean;
const LegalChars:CharSet=['.','\','-','_','?','*','A'..'Z','a'..'z','0'..'9'];
var A:LongInt;
    i:Byte;
begin
 if Prefix(LegalChars) then
  With Owner^ do
   begin
    i:=Curpos+PByte(Name)^;
    CurPos:=i;
    While (CurPos<=Length(ParseStr))and (ParseStr[CurPos] in LegalChars) do
     inc(CurPos);
     PString(RelatedVar)^:=Copy(ParseStr,i,CurPos-i);
   Processed:=True;
  end
 else
  Processed:=False;
end;
Function TOnOffKey.Processed:Boolean;
const LegalChars:CharSet=['+','-'];
begin
 if Prefix(LegalChars) then
   begin
     With Owner^ do
      PBoolean(RelatedVar)^:=ParseStr[CurPos+PByte(Name)^]='+';
    inc(Owner^.CurPos,Succ(PByte(Name)^));
    Processed:=True;
   end
  else
   Processed:=False;
end;
Function TOnKey.Processed:Boolean;
begin
 if Prefix(WordDelimiters) then
   begin
    With Owner^ do
     PBoolean(RelatedVar)^:=True;
    inc(Owner^.CurPos,PByte(Name)^);
    Processed:=True;
   end
  else
   Processed:=False;
end;
Function TOffKey.Processed:Boolean;
begin
 if Prefix(WordDelimiters) then
   begin
    With Owner^ do
     PBoolean(RelatedVar)^:=False;
    inc(Owner^.CurPos,PByte(Name)^);
    Processed:=True;
   end
  else
   Processed:=False;
end;
Function TImmediateKey.Processed:Boolean;
Type p=Procedure;
begin
 if Prefix(WordDelimiters) then
  begin
   Processed:=True;
   P(RelatedVar);
  end
 else
  Processed:=False;
end;
Procedure ParseConfigFile(Parser:PParser;FileName:String);
var S:String;
    F:Text;
begin
 S:=FSearch(FileName,JustPathName(ParamStr(0))+';'+GetEnv('PATH'));
 if S='' then Exit;
 Assign(F,S);
 Reset(F);
 Parser^.NoParams:=True;
 Repeat;
  Readln(F,S);
  Parser^.ParseLine(S);
 Until SeekEof(F);
 Close(F);
end;
Procedure ParseCommandLine(Parser:PParser);
var P:PString;T:POption;
begin
 T:=Parser^.KeyList;
 While T<>nil do begin T^.Clear;T:=T^.Next end;
 P:=Ptr(PrefixSeg,$80);
 Parser^.NoParams:=False;
 Parser^.ParseLine(P^);
 Parser^.CheckRequired;
end;
end.
